#include "StdAfx.h"
#include "WASGetMessages.h"

CWASGetMessages::CWASGetMessages(CWASActor *pActor) : CWASCommand(pActor)
{
}

CWASGetMessages::~CWASGetMessages(void)
{
}

void CWASGetMessages::ExecuteAsync()
{
	USES_UTF8_CONVERSION;

	CMessengerActor *pMessengerActor = static_cast<CMessengerActor *>(m_pActor->GetMessengerActor());
	if(pMessengerActor == NULL)
	{
		return;
	}	

	m_listMessage.clear();

	WSTRING strURL = m_pActor->GetWASServerAddress();
	strURL += _T("/ne/chat/GetMyMessage03.php");

	m_httpFacade.session().SetURL(W2U8(strURL.c_str()),	pMessengerActor->GetMessengerTicket());
	m_httpFacade.session().SetMethod(HTTP_METHOD_POST);

	m_httpFacade.session().AddBodyVariable("userid", W2U8(pMessengerActor->GetUserID()));
	m_httpFacade.session().AddBodyVariable("ticket", pMessengerActor->GetMessengerTicket());

	char szTmp[64];
	sprintf(szTmp, "%d", m_nRoomId);
	m_httpFacade.session().AddBodyVariable("room_id", szTmp);

	sprintf(szTmp, "%d", m_nJoinSeq);
	m_httpFacade.session().AddBodyVariable("join_number", szTmp);
	
	sprintf(szTmp, "%d", m_nFromMsgNum);
	m_httpFacade.session().AddBodyVariable("from_msg_seq", szTmp);

    sprintf(szTmp, "%d", m_nToMsgNum);
    m_httpFacade.session().AddBodyVariable("to_msg_seq", szTmp);

	//   ޽  ,   
	sprintf(szTmp, "%d", m_nSendSuccess);
	m_httpFacade.session().AddBodyVariable("success_msg", szTmp);

	m_httpFacade.session().SetKeepRawHeader(TRUE);

	m_httpFacade.StopRequest();
	m_httpFacade.SendRequest(this);
}

bool CWASGetMessages::ParseAndEventFire(nfc::CIkXMLDom * pDom)
{
	if(pDom == NULL)
		return false;

	nfc::IIkXMLNode* pNode = pDom->GetdocumentElement()->selectSingleNode("room");
	if (pNode == NULL)
	{
		return false;
	}

	nfc::IIkXMLNodeList *pList = pNode->selectNodes("message");	
	nfc::IIkXMLAttribute* pAttr;
	USES_CONVERSION;
	USES_UTF8_CONVERSION;

	m_listMessage.clear();

	for (int i = 0; i < pList->Getlength(); i++)
	{	
		NE_MESSAGE_DATA messageData;
		memset(&messageData, 0x00, sizeof(NE_MESSAGE_DATA));

		pNode = pList->Getitem(i);
		GT_ASSERT(pNode);

		if (NULL == (pAttr = pNode->getAttribute("msg_seq")))
			continue;	// ignore this item

		if (NULL != (pAttr = pNode->getAttribute("msg_seq")))
			messageData.nMsgSeq = atoi(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("from_user")))
			messageData.strFromUserId = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("from_user_nm")))
			messageData.strFromUserName = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("msg")))
			messageData.strMessage = U82W(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("msg_type")))
			messageData.nMsgType = atoi(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("trid")))
			messageData.nTrid= atoi(pAttr->Gettext().c_str());

		if (NULL != (pAttr = pNode->getAttribute("recv_time")))
			messageData.nRecvTime = atoi(pAttr->Gettext().c_str());

		m_listMessage.push_back(messageData);
	}

	return true;
}

// override in drived class
void CWASGetMessages::OnWasResponse(trid_t trid,
									  bool bSuccess,
									  int /*nWinINetErrorCode*/, 
									  int /*nHttpResponseCode*/, 
									  LPCSTR /*szWasResCodeInHeader*/, 
									  LPCSTR szWasResCodeInXml,
									  nfc::CIkXMLDom * pDom)
{
	if(bSuccess)
	{
		if(ParseAndEventFire(pDom) == false)
			m_eError = wasError_Protocol;
	}

	GT_ASSERT(m_pActor);

	//CRITICAL_SECTION * pCS = m_pActor->GetCriticalSection();
	//EnterCriticalSection(pCS);

	CGTObserved<IGTWASActorEvent>::listobserver_t observers;
	m_pActor->GetObservers(&observers);
	CGTObserved<IGTWASActorEvent>::listobserver_t::iterator it = observers.begin();

	for (; it != observers.end(); ++it)
	{
		IGTWASActorEvent *pObserver = static_cast<IGTWASActorEvent *>(*it);
		if(pObserver->OnGTWASActor_ResponseGetMessages(m_pActor, GetID(), m_eError, m_listMessage) == false)
		{
			break;
		}
	}

	//LeaveCriticalSection(pCS);

	if(m_pActor)
		m_pActor->DeleteCommand(GetID());
}


void CWASGetMessages::OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/)
{
	m_eError = wasError_Timeout;

	GT_ASSERT(m_pActor);

	//CRITICAL_SECTION * pCS = m_pActor->GetCriticalSection();
	//EnterCriticalSection(pCS);

	CGTObserved<IGTWASActorEvent>::listobserver_t observers;
	m_pActor->GetObservers(&observers);
	CGTObserved<IGTWASActorEvent>::listobserver_t::iterator it = observers.begin();	

	for (; it != observers.end(); ++it)
	{
		IGTWASActorEvent *pObserver = static_cast<IGTWASActorEvent *>(*it);
		if(pObserver->OnGTWASActor_ResponseGetMessages(m_pActor, GetID(), m_eError, m_listMessage) == false)
		{
			break;
		}
	}

	//LeaveCriticalSection(pCS);

	if(m_pActor)
		m_pActor->DeleteCommand(GetID());
}
